/* --------------------------------------------------
Author: Anastasios Pallas / tcpallas@gmail.com
Version 3.2
Last Update: 2018-11-22
-------------------------------------------------- */

// Configuration and Default Values

// Usage: config.f1_min;

var config = {
	center_x: 530,
	center_y: 350,
	
	pick_device_title: "Εισάγετε συσκευή στο ηλεκτρολογικό κύκλωμα",
	blackbox_question_line1: "Έχετε εισάγει στο κύκλωμα μια άγνωστη συσκευή!",
	blackbox_question_line2: "Υπολογίστε τις τιμές R, L και C.",
	circuit_tab1_text: "Κύκλωμα",
	circuit_tab2_text: "Τρίγωνο Ισχύος",
	circuit_tab3_text: "Κυματομορφές V/I",

	device_1pmotor_QL: 1500,
	device_1pmotor_QC: 2,
	device_1pmotor_P: 3700,
	device_1pmotor_label: "Μονοφασικός Κινητήρας",
	
	device_kitchen_QL: 0,
	device_kitchen_QC: 0,
	device_kitchen_P: 3500,
	device_kitchen_label: "Ηλεκτρικές Εστίες",
	
	device_washing_QL: 1106,
	device_washing_QC: 0,
	device_washing_P: 2800,
	device_washing_label: "Πλυντήριο Ρούχων",
	
	device_capacitor_QL: 0,
	device_capacitor_QC: 1500,
	device_capacitor_P: 0,
	device_capacitor_label: "Πυκνωτής #1",

	device_capacitor2_QL: 0,
	device_capacitor2_QC: 7000,
	device_capacitor2_P: 0,
	device_capacitor2_label: "Πυκνωτής #2",

	device_capacitor3_QL: 0,
	device_capacitor3_QC: 14000,
	device_capacitor3_P: 0,
	device_capacitor3_label: "Πυκνωτής #3",
	
	device_coil_QL: 200,
	device_coil_QC: 0,
	device_coil_P: 0,
	device_coil_label: "Ομάδα Πηνίων",
	
	/*
	device_3pmotor_QL: 200,
	device_3pmotor_QC: 0,
	device_3pmotor_P: 200,
	device_3pmotor_label: "Τριφασικός Κινητήρας",
	*/
	
	device_vcleaner_QL: 1380,
	device_vcleaner_QC: 0,
	device_vcleaner_P: 1840,
	device_vcleaner_label: "Ηλεκτρική Σκούπα",

	device_cnc_QL: 6000,
	device_cnc_QC: 0,
	device_cnc_P: 8000,
	device_cnc_label: "Μηχάνημα CNC",

	device_blackbox_default_label: "Άγνωστη Συσκευή",
	
	device_blackbox_label: "",
	device_blackbox_QL: 0,
	device_blackbox_QC: 0,
	device_blackbox_P: 0,
	device_blackbox_R: 0,
	device_blackbox_R_unit: "Ω",
	device_blackbox_L: 0,
	device_blackbox_L_unit: "H",
	device_blackbox_C: 0,
	device_blackbox_C_unit: "μF",
	device_blackbox_amp_meter: 0,

	click_area_color: "rgba(255, 255, 255, 0.01)"	// for development use: #ff000010 - for production use: #ffffff10
}

var blackbox = {
	0 : {
		device_blackbox_label: "Πηνίο",
		device_blackbox_QL: 841.8,
		device_blackbox_QC: 0,
		device_blackbox_P: 0,
		device_blackbox_R: 0,
		device_blackbox_R_unit: "Ω",
		device_blackbox_L: 0.2,
		device_blackbox_L_unit: "H",
		device_blackbox_C: 0,
		device_blackbox_C_unit: "mF",
		device_blackbox_amp_meter: 3.66
	},
	1 : {
		device_blackbox_label: "Πυκνωτής",
		device_blackbox_QL: 0,
		device_blackbox_QC: 4986.4,
		device_blackbox_P: 0,
		device_blackbox_R: 0,
		device_blackbox_R_unit: "Ω",
		device_blackbox_L: 0,
		device_blackbox_L_unit: "H",
		device_blackbox_C: 0.3,
		device_blackbox_C_unit: "mF",
		device_blackbox_amp_meter: 21.68
	},
	2 : {
		device_blackbox_label: "Ηλεκτρικό Τρυπάνι",
		device_blackbox_QL: 475.97,
		device_blackbox_QC: 0,
		device_blackbox_P: 757.59,
		device_blackbox_R: 50,
		device_blackbox_R_unit: "Ω",
		device_blackbox_L: 0.1,
		device_blackbox_L_unit: "H",
		device_blackbox_C: 0,
		device_blackbox_C_unit: "mF",
		device_blackbox_amp_meter: 3.89
	},
	3 : {
		device_blackbox_label: "Ηλεκτρονική Πλακέτα",
		device_blackbox_QL: 0,
		device_blackbox_QC: 0.37,
		device_blackbox_P: 35.11,
		device_blackbox_R: 1500,
		device_blackbox_R_unit: "Ω",
		device_blackbox_L: 0,
		device_blackbox_L_unit: "H",
		device_blackbox_C: 0.2,
		device_blackbox_C_unit: "mF",
		device_blackbox_amp_meter: 0.153	
	},
	4 : {
		device_blackbox_label: "Λαμπτήρας",
		device_blackbox_QL: 0,
		device_blackbox_QC: 0,
		device_blackbox_P: 529,
		device_blackbox_R: 100,
		device_blackbox_R_unit: "Ω",
		device_blackbox_L: 0,
		device_blackbox_L_unit: "H",
		device_blackbox_C: 0,
		device_blackbox_C_unit: "mF",
		device_blackbox_amp_meter: 2.3	
	}
}

// Get a random blackbox
var blackbox_len = 5;
var rnd = Math.floor((Math.random() * (blackbox_len-1) ) + 0);

// Debugging
console.log('Rnd blackbox: ' + rnd);

config.device_blackbox_label 	= blackbox[rnd].device_blackbox_label;
config.device_blackbox_QL 		= blackbox[rnd].device_blackbox_QL;
config.device_blackbox_QC		= blackbox[rnd].device_blackbox_QC;
config.device_blackbox_P		= blackbox[rnd].device_blackbox_P;
config.device_blackbox_R		= blackbox[rnd].device_blackbox_R;
config.device_blackbox_R_unit	= blackbox[rnd].device_blackbox_R_unit;
config.device_blackbox_L		= blackbox[rnd].device_blackbox_L;
config.device_blackbox_L_unit	= blackbox[rnd].device_blackbox_L_unit;
config.device_blackbox_C		= blackbox[rnd].device_blackbox_C;
config.device_blackbox_C_unit	= blackbox[rnd].device_blackbox_C_unit;
config.device_blackbox_amp_meter= blackbox[rnd].device_blackbox_amp_meter;


// Create a random number (rounded to 10)
// var r1_rnd = Math.floor((Math.random() * config.r1_max) + config.r1_min);
// r1_rnd = Math.round(r1_rnd / 10) * 10;
// config.r1_value = r1_rnd;

