/* --------------------------------------------------
Author: Anastasios Pallas / tcpallas@gmail.com
Version 3.2
Last Update: 2018-11-22
-------------------------------------------------- */

// Fix responsive for canvas overlay objects
// based on the screen resolution

$(document).ready(function(){
	handle_window_resize();
});
 

$(window).on('resize', function(){
	handle_window_resize();
});


function handle_window_resize() {

	var screenwidth = $(window).width();
	
	if (screenwidth < 1140) {
		/*
		var scale = screenwidth / 1140;
		scale = Math.round(scale * 100) / 100;
		$("#canvas_overlay").css("zoom", scale);
		$("#circuit_values_txt").css("zoom", scale);
		$("#blackbox").css("zoom", scale);
		$("#btn_theory").css("zoom", scale);
		$("#btn_application").css("zoom", scale);
		$("#btn_investigation").css("zoom", scale);

		$("#canvas_overlay").css("transform", "scale(" + scale + ")");
		$("#circuit_values_txt").css("transform", "scale(" + scale + ")");
		$("#blackbox").css("transform", "scale(" + scale + ")");
		$("#btn_theory").css("transform", "scale(" + scale + ")");
		$("#btn_application").css("transform", "scale(" + scale + ")");
		$("#btn_investigation").css("transform", "scale(" + scale + ")");
		*/

		// disable tooltips
		$("#btn_theory").tooltip('disable');
		$("#btn_application").tooltip('disable');
		$("#btn_investigation").tooltip('disable');
	} else {
		/*
		$("#canvas_overlay").css("zoom", "normal");
		$("#circuit_values_txt").css("zoom", "normal");
		$("#blackbox").css("zoom", "normal");
		$("#btn_theory").css("zoom", "normal");
		$("#btn_application").css("zoom", "normal");
		$("#btn_investigation").css("zoom", "normal");
		$("#canvas_overlay").css("transform", "none");
		*/

		// enable tooltips
		$("#btn_theory").tooltip('enable');
		$("#btn_application").tooltip('enable');
		$("#btn_investigation").tooltip('enable');
	}

}



// Theory Button
$("#btn_theory").tooltip();
$("#btn_theory").click(function() {
	$("#theory_instruction_modal").modal('show');
});


// Application Button
$("#btn_application").tooltip();
$("#btn_application").click(function() {
	$("#application_instruction_modal").modal('show');
});


// Investigation Button
$("#btn_investigation").tooltip();
$("#btn_investigation").click(function() {
	$("#investigation_instruction_modal").modal('show');
});




// Blackbox Inputs

$("#blackbox_R input").change(function() {
	$("#blackbox_R .fa-check").hide();
	$("#blackbox_R .fa-times").hide();
});


$("#blackbox_L input").change(function() {
	$("#blackbox_L .fa-check").hide();
	$("#blackbox_L .fa-times").hide();
});


$("#blackbox_C input").change(function() {
	$("#blackbox_C .fa-check").hide();
	$("#blackbox_C .fa-times").hide();
});


/*
// Theory Button
$("#theory_instruction_tooltip").tooltip();
$("#theory_instruction_tooltip").click()
theory_btn_area.addEventListener("click", function() {
	handleClick_theory_btn();
});


// Application Button
$("#application_instruction_tooltip").tooltip();
application_btn.addEventListener("click", function() {
	handleClick_application_btn();
});

// Investigation Button
$("#investigation_instruction_tooltip").tooltip();
invest_btn.addEventListener("click", function() {
	handleClick_invest_btn();
});
*/

// Device Prev
device_arrow_prev.addEventListener("click", function() {
	handleClick_device_prev(circuit_array);
});

// Device Next
device_arrow_next.addEventListener("click", function() {
	handleClick_device_next(circuit_array);
});

// Add Device 
device_add_btn.addEventListener("click", function() {
	handleClick_device_add(circuit_array);
});

// Remove 1st device
rm_device[0].addEventListener("click", function() {
	handleClick_device_remove(circuit_array, 0);
});

// Remove 2nd device
rm_device[1].addEventListener("click", function() {
	handleClick_device_remove(circuit_array, 1);
});

// Remove 3rd device
rm_device[2].addEventListener("click", function() {
	handleClick_device_remove(circuit_array, 2);
});

// Remove 4th device
rm_device[3].addEventListener("click", function() {
	handleClick_device_remove(circuit_array, 3);
});


// Remove 5th device
rm_device[4].addEventListener("click", function() {
	handleClick_device_remove(circuit_array, 4);
});


// Check Blackbox
blackbox_check_btn.addEventListener("click", function() {
	handleClick_blackbox_check();
});


// Change Tabs
circuit_tab1.addEventListener("click", function() {
	handleClick_tab1();
});

circuit_tab2.addEventListener("click", function() {
	handleClick_tab2();
});

circuit_tab3.addEventListener("click", function() {
	handleClick_tab3();
});


//

/*
function handleClick_theory_btn() {
	$("#theory_instruction_modal").modal('show');
	return true;
}

function handleClick_application_btn() {
	$("#application_instruction_modal").modal('show');
	return true;	
}

function handleClick_invest_btn() {
	$("#investigation_instruction_modal").modal('show');
	return true;
}
*/


function handleClick_device_next(circuit_array) {

	// Order: 1pmotor > kitchen > washing-machine > capacitor > capacitor2 > capacitor3 > coil > vcleaner > blackbox > cnc

	if (device_1pmotor.visible) {
		update_device_circuit("kitchen");
	} else if (device_kitchen.visible) {
		update_device_circuit("washing-machine");
	} else if (device_washing.visible) {
		update_device_circuit("capacitor");
	} else if (device_capacitor.visible) {
		update_device_circuit("capacitor2");
	} else if (device_capacitor2.visible) {
		update_device_circuit("capacitor3");
	} else if (device_capacitor3.visible) {
		update_device_circuit("coil");
	} else if (device_coil.visible) {
		update_device_circuit("vcleaner");
	} else if (device_vcleaner.visible) {
		update_device_circuit("blackbox");
	} else if (device_blackbox.visible) {
		update_device_circuit("cnc");
	} else if (device_cnc.visible) {
		update_device_circuit("1phase-motor");
	}

	update_device_button(circuit_array);

	return true;

}



function handleClick_device_prev(circuit_array) {

	// Order: 1pmotor < kitchen < washing-machine < capacitor < capacitor2 < capacitor3 < coil < vcleaner < blackbox < cnc

	if (device_1pmotor.visible) {
		update_device_circuit("cnc");
	} else if (device_kitchen.visible) {
		update_device_circuit("1phase-motor");
	} else if (device_washing.visible) {
		update_device_circuit("kitchen");
	} else if (device_capacitor.visible) {
		update_device_circuit("washing-machine");
	} else if (device_capacitor2.visible) {
		update_device_circuit("capacitor");
	} else if (device_capacitor3.visible) {
		update_device_circuit("capacitor2");
	} else if (device_coil.visible) {
		update_device_circuit("capacitor3");
	} else if (device_vcleaner.visible) {
		update_device_circuit("coil");
	} else if (device_blackbox.visible) {
		update_device_circuit("vcleaner");
	} else if (device_cnc.visible) {
		update_device_circuit("blackbox");
	}

	update_device_button(circuit_array);

	return true;

}




function handleClick_device_add(circuit_array) {

	// Check which position is empty
	circuit_position = -1;	//  no empty position
	if (circuit_array[0] == "add_circuit") {
		circuit_position = 0;
	} else if (circuit_array[1] == "add_circuit") {
		circuit_position = 1;
	} else if (circuit_array[2] == "add_circuit") {
		circuit_position = 2;
	} else if (circuit_array[3] == "add_circuit") {
		circuit_position = 3;
	} else if (circuit_array[4] == "add_circuit") {
		circuit_position = 4;
	}
	
	if (circuit_position >= 0) {

		if (device_1pmotor.visible) {
			circuit_array[circuit_position] = "1phase-motor";
		} else if (device_kitchen.visible) {
			circuit_array[circuit_position] = "kitchen";
		} else if (device_washing.visible) {
			circuit_array[circuit_position] = "washing-machine";
		} else if (device_capacitor.visible) {
			circuit_array[circuit_position] = "capacitor";
		} else if (device_capacitor2.visible) {
			circuit_array[circuit_position] = "capacitor2";
		} else if (device_capacitor3.visible) {
			circuit_array[circuit_position] = "capacitor3";
		} else if (device_coil.visible) {
			circuit_array[circuit_position] = "coil";
		// } else if (device_3pmotor.visible) {
		//  	circuit_array[circuit_position] = "3phase-motor";
		} else if (device_vcleaner.visible) {
			circuit_array[circuit_position] = "vcleaner";
		} else if (device_cnc.visible) {
			circuit_array[circuit_position] = "cnc";
		} else if (device_blackbox.visible) {
			circuit_array[circuit_position] = "blackbox";
		}

		// Move "Add Circuit" to the next available position
		if (circuit_array[0] == "") {
			circuit_array[0] = "add_circuit";
		} else if (circuit_array[1] == "") {
			circuit_array[1] = "add_circuit";
		} else if (circuit_array[2] == "") {
			circuit_array[2] = "add_circuit";
		} else if (circuit_array[3] == "") {
			circuit_array[3] = "add_circuit";
		} else if (circuit_array[4] == "") {
			circuit_array[4] = "add_circuit";
		}


		// Update Main Circuit
		update_circuit(circuit_array);

	}

}


function handleClick_device_remove(circuit_array, position) {

	circuit_array[position] = "";


	// Reorganize Main Circuit
	for (i = 0; i < circuit_array.length-1; i++) { 
    	if (circuit_array[i]=="" && circuit_array[i+1]!="") {
    		circuit_array[i] = circuit_array[i+1];
    		circuit_array[i+1] = "";
    	}
    }

	// Update Main Circuit
	update_circuit(circuit_array);
	
	return true;

}



function handleClick_blackbox_check() {

	// Get user values from input 
	var input_R = $("#blackbox_R input").val();
	var input_L = $("#blackbox_L input").val();
	var input_C = $("#blackbox_C input").val();

	// Remove spaces and convert , to .
	input_R = input_R.trim().replace(",", ".");
	input_L = input_L.trim().replace(",", ".");
	input_C = input_C.trim().replace(",", ".");
	
	if (input_R=="") input_R = 0;
	if (input_L=="") input_L = 0;
	if (input_C=="") input_C = 0;
	
	// Convert to number
	input_R = parseFloat(input_R);
	input_L = parseFloat(input_L);
	input_C = parseFloat(input_C);

	// Round values L and C
	input_R = Math.round(input_R);				// round to integer
	input_L = Math.round(input_L * 10) / 10;	// round to 1 decimal
	input_C = Math.round(input_C * 10) / 10;	// round to 1 decimal

	// Update input values
	$("#blackbox_R input").val(input_R);
	$("#blackbox_L input").val(input_L);
	$("#blackbox_C input").val(input_C);


	// Check R
	if (input_R == config.device_blackbox_R) {
		$("#blackbox_R .fa-check").show();
		$("#blackbox_R .fa-times").hide();
	} else {
		$("#blackbox_R .fa-times").show();
		$("#blackbox_R .fa-check").hide();
	}

	// Check L
	if (input_L == config.device_blackbox_L) {
		$("#blackbox_L .fa-check").show();
		$("#blackbox_L .fa-times").hide();
	} else {
		$("#blackbox_L .fa-times").show();
		$("#blackbox_L .fa-check").hide();
	}

	// Check C
	if (input_C == config.device_blackbox_C) {
		$("#blackbox_C .fa-check").show();
		$("#blackbox_C .fa-times").hide();
	} else {
		$("#blackbox_C .fa-times").show();
		$("#blackbox_C .fa-check").hide();
	}

	// User discovered the blackbox device
	if (input_R == config.device_blackbox_R && input_L == config.device_blackbox_L && input_C == config.device_blackbox_C) {

		// Show device
		blackbox_label = "✔ " + config.device_blackbox_label;

		// Hide check button
		blackbox_check_btn.graphics.clear().beginFill("white").drawRoundRect(0, 0, 106, 25, 0);
		blackbox_check_btn.cursor = "";

	} else {

		// Show default label
		blackbox_label = config.device_blackbox_default_label;

		// Show check button
		blackbox_check_btn.graphics.clear().beginFill(config.click_area_color).drawRoundRect(0, 0, 106, 25, 0);
		blackbox_check_btn.cursor = "pointer";
	}


	// Update Main Circuit
	update_circuit(circuit_array);

	return true;

}




// TABS

function handleClick_tab1() {

	// Update tabs
	circuit_tab1.cursor = "";
	circuit_tab2.cursor = "pointer";
	circuit_tab3.cursor = "pointer";

	circuit_tab1.graphics.clear().beginFill("#00aeef").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 120, 40, 10);
	circuit_tab2.graphics.clear().beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);
	circuit_tab3.graphics.clear().beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);

	circuit_tab1_text.color = "#ffffff";
	circuit_tab2_text.color = "#00aeef";
	circuit_tab3_text.color = "#00aeef";

	// Show/Hide Remove Buttons
	for (i = 0; i < circuit_array.length; i++) {
    	if (circuit_array[i]=="" || circuit_array[i]=="add_circuit") {
    		rm_device[i].visible = false;
    	} else {
    		rm_device[i].visible = true;
    	}
	}

	// Hide elements of 2nd tab
	tab2_overlay.visible = false;	
	diagram_P.visible = false;
	diagram_Q.visible = false;
	diagram_S.visible = false;
	// diagram_S_arrow.visible = false;
	PHIangle.visible = false;
	PHItext.visible = false;
	label_P.visible = false;
	label_Q.visible = false;
	label_S.visible = false;
	label_SI.visible = false;
	
	// Hide elements of 3rd tab
	tab3_overlay.visible = false;
	plot_axes.visible = false;
	v_plot.visible = false;
	i_plot.visible = false;
	plot_labels.visible = false;

	stage.update();

}

function handleClick_tab2() {

	// Update tabs
	circuit_tab1.cursor = "pointer";
	circuit_tab2.cursor = "";
	circuit_tab3.cursor = "pointer";

	circuit_tab1.graphics.clear().beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 120, 40, 10);
	circuit_tab2.graphics.clear().beginFill("#00aeef").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);
	circuit_tab3.graphics.clear().beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);

	circuit_tab1_text.color = "#00aeef";
	circuit_tab2_text.color = "#ffffff";
	circuit_tab3_text.color = "#00aeef";

	// Hide elements of 1st tab
	rm_device[0].visible = false;
	rm_device[1].visible = false;
	rm_device[2].visible = false;
	rm_device[3].visible = false;
	rm_device[4].visible = false;


	// Hide elements of 3rd tab
	tab3_overlay.visible = false;
	plot_axes.visible = false;
	v_plot.visible = false;
	i_plot.visible = false;
	plot_labels.visible = false;

	/*
	// Calculate Circuit Values
	var circuit_values = calc_values(circuit_array);

	// Draw Diagrams
	draw_diagrams(circuit_values["P"], circuit_values["QL"], circuit_values["QC"]);
	*/

	
	// Z-index
	// var tab2_zindex = stage.getNumChildren()-1; // getNumbChildren is deprecated!
	var tab2_zindex = stage.numChildren - 1;
	stage.setChildIndex(tab2_overlay, tab2_zindex);
	stage.setChildIndex(diagram_P, tab2_zindex);
	stage.setChildIndex(diagram_Q, tab2_zindex);
	stage.setChildIndex(diagram_S, tab2_zindex);
	// stage.setChildIndex(diagram_S_arrow, tab2_zindex);
	stage.setChildIndex(PHIangle, tab2_zindex);
	stage.setChildIndex(PHItext, tab2_zindex);
	stage.setChildIndex(label_P, tab2_zindex);
	stage.setChildIndex(label_Q, tab2_zindex);
	stage.setChildIndex(label_S, tab2_zindex);
	stage.setChildIndex(label_SI, tab2_zindex);

	// Show 2nd tab elements
	tab2_overlay.visible = true;
	diagram_P.visible = true;
	diagram_Q.visible = true;
	diagram_S.visible = true;
	// diagram_S_arrow.visible = true;
	PHIangle.visible = true;
	PHItext.visible = true;
	label_P.visible = true;
	label_Q.visible = true;
	label_S.visible = true;
	label_SI.visible = true;

	stage.update();

}

function handleClick_tab3() {

	// Update tabs
	circuit_tab1.cursor = "pointer";
	circuit_tab2.cursor = "pointer";
	circuit_tab3.cursor = "";

	circuit_tab1.graphics.clear().beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 120, 40, 10);
	circuit_tab2.graphics.clear().beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);
	circuit_tab3.graphics.clear().beginFill("#00aeef").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);

	circuit_tab1_text.color = "#00aeef";
	circuit_tab2_text.color = "#00aeef";
	circuit_tab3_text.color = "#ffffff";

	// Hide elements of 1st tab
	rm_device[0].visible = false;
	rm_device[1].visible = false;
	rm_device[2].visible = false;
	rm_device[3].visible = false;
	rm_device[4].visible = false;


	// Hide elements of 2nd tab
	tab2_overlay.visible = false;
	diagram_P.visible = false;
	diagram_Q.visible = false;
	diagram_S.visible = false;
	// diagram_S_arrow.visible = false;
	PHIangle.visible = false;
	PHItext.visible = false;
	label_P.visible = false;
	label_Q.visible = false;
	label_S.visible = false;
	label_SI.visible = false;

	/*
	// Calculate Circuit Values
	var circuit_values = calc_values(circuit_array);

	var Q = circuit_values["QL"] - circuit_values["QC"];

	// Draw Wave Plots
	draw_waveplot_V();
	draw_waveplot_I(circuit_values["P"], Q);
	*/


	// Z-index
	var tab3_zindex = stage.numChildren - 1;
	stage.setChildIndex(tab3_overlay, tab3_zindex);
	stage.setChildIndex(plot_axes, tab3_zindex);
	stage.setChildIndex(v_plot, tab3_zindex);
	stage.setChildIndex(i_plot, tab3_zindex);
	stage.setChildIndex(plot_labels, tab3_zindex);

	// Show 3rd tab elements
	tab3_overlay.visible = true;
	plot_axes.visible = true;
	v_plot.visible = true;
	i_plot.visible = true;
	plot_labels.visible = true;

	stage.update();
}


