/* --------------------------------------------------
Author: Anastasios Pallas / tcpallas@gmail.com
Version 3.2
Last Update: 2018-11-22
-------------------------------------------------- */


// Update stage will render next frame
createjs.Ticker.framerate = 30;
createjs.Ticker.addEventListener("tick", tickHandler);

function tickHandler(e) {
	stage.update();
}




function update_device_circuit(device) {

	// Hide all devices
	device_1pmotor.visible = false;
	device_kitchen.visible = false;
	device_washing.visible = false;
	device_capacitor.visible = false;
	device_capacitor2.visible = false;
	device_capacitor3.visible = false;
	device_coil.visible = false;
	// device_3pmotor.visible = false;
	device_vcleaner.visible = false;
	device_cnc.visible = false;
	device_blackbox.visible = false;

	// Hide all device circuits
	device_circuit_R.visible = false;
	device_circuit_L.visible = false;
	device_circuit_C.visible = false;
	device_circuit_RL.visible = false;
	device_circuit_RLC.visible = false;
	device_circuit_blackbox.visible = false;


	// Show the selected device and its circuit
	switch(device) {
		case "1phase-motor":
			device_1pmotor.visible = true;
			device_circuit_RLC.visible = true;
			break;
		case "kitchen":
			device_kitchen.visible = true;
			device_circuit_R.visible = true;
			break;
		case "washing-machine":
			device_washing.visible = true;
			device_circuit_RL.visible = true;
			break;
		case "capacitor":
			device_capacitor.visible = true;
			device_circuit_C.visible = true;
			break;
		case "capacitor2":
			device_capacitor2.visible = true;
			device_circuit_C.visible = true;
			break;
		case "capacitor3":
			device_capacitor3.visible = true;
			device_circuit_C.visible = true;
			break;
		case "coil":
			device_coil.visible = true;
			device_circuit_L.visible = true;
			break;
		// case "3phase-motor":
		//	device_3pmotor.visible = true;
		//	device_circuit_RL.visible = true;
		//  break;
		case "vcleaner":
			device_vcleaner.visible = true;
			device_circuit_RL.visible = true;
			break;
		case "cnc":
			device_cnc.visible = true;
			device_circuit_RL.visible = true;
			break;
		case "blackbox":
			device_blackbox.visible = true;
			device_circuit_blackbox.visible = true;
			break;
	}

	// Update stage
	stage.update();

	return true;

}

function update_device_button (circuit_array) {

	device_add.visible = true;
	device_add_btn.visible = true;
	
	// Hide Add button if no more empty positions
	if ( circuit_array.indexOf("add_circuit")==-1 ) {
		device_add.visible = false;
		device_add_btn.visible = false;
	}

	// Hide Add button if already a blackbox device is added
	if (device_blackbox.visible && circuit_array.indexOf("blackbox")>=0 ) {
		device_add.visible = false;
		device_add_btn.visible = false;
	}

	return true;
}



function update_circuit(circuit_array){

	// Debugging
	// console.log(circuit_array);

	// Put Add a New Circuit if necessary
	/*
	if (circuit_array[0] == "") {
		circuit_array[0] = "add_circuit";
	} 
	
	else if (circuit_array[1] == "") {
		circuit_array[1] = "add_circuit";
	} else if (circuit_array[2] == "") {
		circuit_array[2] = "add_circuit";
	} else if (circuit_array[3] == "") {
		circuit_array[3] = "add_circuit";
	} else if (circuit_array[4] == "") {
		circuit_array[4] = "add_circuit";
	} else {
		// None of the circuits areas are empty
		circuit_add.visible = false;
	}
	*/

	// Init labels
	circuit_label1.font = "14px Arial";
	circuit_label2.font = "14px Arial";
	circuit_label3.font = "14px Arial";
	circuit_label4.font = "14px Arial";
	circuit_label5.font = "14px Arial";
	circuit_label1.color = "#00adf2";
	circuit_label2.color = "#00adf2";
	circuit_label3.color = "#00adf2";
	circuit_label4.color = "#00adf2";
	circuit_label5.color = "#00adf2";


	for (i = 0; i < circuit_array.length; i++) {
		if (circuit_array[i] == "add_circuit") {
			break;
		}
		if (circuit_array[i] == "") {
			circuit_array[i] = "add_circuit";
			break;
		}
	}
	

	// Position 1
	switch(circuit_array[0]) {
		case "add_circuit":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_C.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_add.x = config.center_x - 460;
			circuit_add.visible = true;
			circuit_label1.text = "";
			break;
		case "1phase-motor":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_C.visible = false;
			circuit_RL.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_RLC.x = config.center_x - 460;
			circuit_RLC.visible = true;
			circuit_label1.text = config.device_1pmotor_label;
			break;
		case "kitchen":
			// hide any previous circuit
			circuit_L.visible = false;
			circuit_C.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_R.x = config.center_x - 460;
			circuit_R.visible = true;
			circuit_label1.text = config.device_kitchen_label;
			break;
		case "washing-machine":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_C.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_RL.x = config.center_x - 460;
			circuit_RL.visible = true;
			circuit_label1.text = config.device_washing_label;
			break;
		/*
		case "3phase-motor":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_C.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_RL.x = config.center_x - 460;
			circuit_RL.visible = true;
			circuit_label1.text = config.device_3pmotor_label;
			break;
		*/
		case "vcleaner":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_C.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_RL.x = config.center_x - 460;
			circuit_RL.visible = true;
			circuit_label1.text = config.device_vcleaner_label;
			break;
		case "capacitor":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_C.x = config.center_x - 460;
			circuit_C.visible = true;
			circuit_label1.text = config.device_capacitor_label;
			break;
		case "capacitor2":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_C.x = config.center_x - 460;
			circuit_C.visible = true;
			circuit_label1.text = config.device_capacitor2_label;
			break;
		case "capacitor3":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_C.x = config.center_x - 460;
			circuit_C.visible = true;
			circuit_label1.text = config.device_capacitor3_label;
			break;
		case "coil":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_C.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_L.x = config.center_x - 460;
			circuit_L.visible = true;
			circuit_label1.text = config.device_coil_label;
			break;
		case "cnc":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_C.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			circuit_blackbox.visible = false;
			// show
			circuit_RL.x = config.center_x - 460;
			circuit_RL.visible = true;
			circuit_label1.text = config.device_cnc_label;
			break;
		case "blackbox":
			// hide any previous circuit
			circuit_R.visible = false;
			circuit_L.visible = false;
			circuit_C.visible = false;
			circuit_RL.visible = false;
			circuit_RLC.visible = false;
			// show
			circuit_blackbox.x = config.center_x - 460;
			circuit_blackbox.visible = true;
			blackbox_ampmeter_txt.text = "I=" + config.device_blackbox_amp_meter + "A";
			blackbox_ampmeter_txt.x = config.center_x - 370;
			circuit_label1.text = blackbox_label;
			if (blackbox_label!=config.device_blackbox_default_label) {
				circuit_label1.font = "16px Arial";
				circuit_label1.color = "green";
			} else {
				circuit_label1.font = "14px Arial";
				circuit_label1.color = "red";
			}
			break;
	}

	
	// Position 2
	switch(circuit_array[1]) {
		case "add_circuit":
			// Hide any previous circuit
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_add.x = config.center_x - 265;
			circuit_add.visible = true;
			circuit_label2.text = "";
			break;
		case "1phase-motor":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = true;
			circuit_label2.text = config.device_1pmotor_label;
			break;
		case "kitchen":
			circuit_R2.visible = true;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_kitchen_label;
			break;
		case "washing-machine":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = true;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_washing_label;
			break;
		/*
		case "3phase-motor":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = true;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_3pmotor_label;
			break;
		*/
		case "vcleaner":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = true;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_vcleaner_label;
			break;
		case "capacitor":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = true;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_capacitor_label;
			break;
		case "capacitor2":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = true;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_capacitor2_label;
			break;
		case "capacitor3":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = true;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_capacitor3_label;
			break;
		case "coil":
			circuit_R2.visible = false;
			circuit_L2.visible = true;
			circuit_C2.visible = false;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_coil_label;
			break;
		case "cnc":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = true;
			circuit_RLC2.visible = false;
			circuit_label2.text = config.device_cnc_label;
			break;
		case "blackbox":
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_blackbox.x = config.center_x - 265;
			circuit_blackbox.visible = true;
			circuit_label2.text = blackbox_label;
			if (blackbox_label!=config.device_blackbox_default_label) {
				circuit_label2.font = "16px Arial";
				circuit_label2.color = "green";
			} else {
				circuit_label2.font = "14px Arial";
				circuit_label2.color = "red";
			}
			blackbox_ampmeter_txt.text = "I=" + config.device_blackbox_amp_meter + "A";
			blackbox_ampmeter_txt.x = config.center_x - 175;
			break;
		case "":
			// hide any previous circuit
			circuit_R2.visible = false;
			circuit_L2.visible = false;
			circuit_C2.visible = false;
			circuit_RL2.visible = false;
			circuit_RLC2.visible = false;
			circuit_label2.text = "";
			break;
	}

	// Position 3
	switch(circuit_array[2]) {
		case "add_circuit":
			// hide any previous circuit
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_add.x = config.center_x - 70;
			circuit_add.visible = true;
			circuit_label3.text = "";
			break;
		case "1phase-motor":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = true;
			circuit_label3.text = config.device_1pmotor_label;
			break;
		case "kitchen":
			circuit_R3.visible = true;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_kitchen_label;
			break;
		case "washing-machine":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = true;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_washing_label;
			break;
		/*
		case "3phase-motor":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = true;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_3pmotor_label;
			break;
		*/
		case "vcleaner":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = true;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_vcleaner_label;
			break;
		case "capacitor":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = true;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_capacitor_label;
			break;
		case "capacitor2":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = true;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_capacitor2_label;
			break;
		case "capacitor3":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = true;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_capacitor3_label;
			break;
		case "coil":
			circuit_R3.visible = false;
			circuit_L3.visible = true;
			circuit_C3.visible = false;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_coil_label;
			break;
		case "cnc":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = true;
			circuit_RLC3.visible = false;
			circuit_label3.text = config.device_cnc_label;
			break;
		case "blackbox":
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_blackbox.x = config.center_x - 70;
			circuit_blackbox.visible = true;
			circuit_label3.text = blackbox_label;
			if (blackbox_label!=config.device_blackbox_default_label) {
				circuit_label3.font = "16px Arial";
				circuit_label3.color = "green";
			} else {
				circuit_label3.font = "14px Arial";
				circuit_label3.color = "red";
			}
			blackbox_ampmeter_txt.text = "I=" + config.device_blackbox_amp_meter + "A";
			blackbox_ampmeter_txt.x = config.center_x + 20;
			break;
		case "":
			// hide any previous circuit
			circuit_R3.visible = false;
			circuit_L3.visible = false;
			circuit_C3.visible = false;
			circuit_RL3.visible = false;
			circuit_RLC3.visible = false;
			circuit_label3.text = "";
			break;
	}

	// Position 4
	switch(circuit_array[3]) {
		case "add_circuit":
			// hide any previous circuit
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_add.x = config.center_x + 125;
			circuit_add.visible = true;
			circuit_label4.text = "";
			break;
		case "1phase-motor":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = true;
			circuit_label4.text = config.device_1pmotor_label;
			break;
		case "kitchen":
			circuit_R4.visible = true;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_kitchen_label;
			break;
		case "washing-machine":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = true;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_washing_label;
			break;
		/*
		case "3phase-motor":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = true;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_3pmotor_label;
			break;
		*/
		case "vcleaner":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = true;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_vcleaner_label;
			break;
		case "capacitor":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = true;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_capacitor_label;
			break;
		case "capacitor2":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = true;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_capacitor2_label;
			break;
		case "capacitor3":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = true;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_capacitor3_label;
			break;
		case "coil":
			circuit_R4.visible = false;
			circuit_L4.visible = true;
			circuit_C4.visible = false;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_coil_label;
			break;
		case "cnc":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = true;
			circuit_RLC4.visible = false;
			circuit_label4.text = config.device_cnc_label;
			break;
		case "blackbox":
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_blackbox.x = config.center_x + 125;
			circuit_blackbox.visible = true;
			circuit_label4.text = blackbox_label;
			if (blackbox_label!=config.device_blackbox_default_label) {
				circuit_label4.font = "16px Arial";
				circuit_label4.color = "green";
			} else {
				circuit_label4.font = "14px Arial";
				circuit_label4.color = "red";
			}
			blackbox_ampmeter_txt.text = "I=" + config.device_blackbox_amp_meter + "A";
			blackbox_ampmeter_txt.x = config.center_x + 215;
			break;
		case "":
			// hide any previous circuit
			circuit_R4.visible = false;
			circuit_L4.visible = false;
			circuit_C4.visible = false;
			circuit_RL4.visible = false;
			circuit_RLC4.visible = false;
			circuit_label4.text = "";
			break;
	}


	// Position 5
	switch(circuit_array[4]) {
		case "add_circuit":
			// hide any previous circuit
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = false;
			circuit_add.x = config.center_x + 320;
			circuit_add.visible = true;
			circuit_label5.text = "";
			break;
		case "1phase-motor":
			circuit_add.visible = false;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = true;
			circuit_label5.text = config.device_1pmotor_label;
			break;
		case "kitchen":
			circuit_add.visible = false;
			circuit_R5.visible = true;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = false
			circuit_RLC5.visible = false;
			circuit_label5.text = config.device_kitchen_label;
			break;
		case "washing-machine":
			circuit_add.visible = false;
			circuit_RL5.visible = true;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = true;
			circuit_label5.text = config.device_washing_label;
			break;
		/*
		case "3phase-motor":
			circuit_add.visible = false;
			circuit_RL5.visible = true;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = true;
			circuit_label5.text = config.device_3pmotor_label;
			break;
		*/
		case "vcleaner":
			circuit_add.visible = false;
			circuit_RL5.visible = true;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = true;
			circuit_label5.text = config.device_vcleaner_label;
			break;
		case "capacitor":
			circuit_add.visible = false;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = true;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = false;
			circuit_label5.text = config.device_capacitor_label;
			break;
		case "capacitor2":
			circuit_add.visible = false;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = true;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = false;
			circuit_label5.text = config.device_capacitor2_label;
			break;
		case "capacitor3":
			circuit_add.visible = false;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = true;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = false;
			circuit_label5.text = config.device_capacitor3_label;
			break;
		case "coil":
			circuit_add.visible = false;
			circuit_R5.visible = false;
			circuit_L5.visible = true;
			circuit_C5.visible = false;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = false;
			circuit_label5.text = config.device_coil_label;
			break;
		case "cnc":
			circuit_add.visible = false;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = true;
			circuit_RLC5.visible = false;
			circuit_label5.text = config.device_cnc_label;
			break;
		case "blackbox":
			circuit_add.visible = false;
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = false;
			circuit_blackbox.x = config.center_x + 320;
			circuit_blackbox.visible = true;
			circuit_label5.text = blackbox_label;
			if (blackbox_label!=config.device_blackbox_default_label) {
				circuit_label5.font = "16px Arial";
				circuit_label5.color = "green";
			} else {
				circuit_label5.font = "14px Arial";
				circuit_label5.color = "red";
			}
			blackbox_ampmeter_txt.text = "I=" + config.device_blackbox_amp_meter + "A";
			blackbox_ampmeter_txt.x = config.center_x + 410;
			break;
		case "":
			// hide any previous circuit
			circuit_R5.visible = false;
			circuit_L5.visible = false;
			circuit_C5.visible = false;
			circuit_RL5.visible = false;
			circuit_RLC5.visible = false;
			circuit_label5.text = "";
			break;
	}


	
	var show_blackbox_bubble = false;

	for (i = 0; i < circuit_array.length; i++) {
		
		// Show/Hide Remove Buttons
    	if (circuit_array[i]=="" || circuit_array[i]=="add_circuit") {
    		rm_device[i].visible = false;
    	} else {
    		rm_device[i].visible = true;
    	}

    	// Show/Hide Blackbox_bubble
    	if (circuit_array[i]=="blackbox") {
    		show_blackbox_bubble = true;
    	}

    }

    // Show/Hide Blackbox_bubble
    if (show_blackbox_bubble) {
    	blackbox_bubble.visible = true;
		blackbox_ampmeter_txt.visible = true;
		blackbox_check_btn.visible = true;
		$("#blackbox").show();
		$("#blackbox_R span.unit").html(config.device_blackbox_R_unit);
		$("#blackbox_L span.unit").html(config.device_blackbox_L_unit);
		$("#blackbox_C span.unit").html(config.device_blackbox_C_unit);
    } else {
    	blackbox_bubble.visible = false;
    	blackbox_ampmeter_txt.visible = false;
		blackbox_check_btn.visible = false;
		$("#blackbox").hide();
    }


    // Update Device Buttons
    update_device_button(circuit_array);

    // Update Circuit Values
    var circuit_values = calc_values (circuit_array);

	var Q = circuit_values["QL"] - circuit_values["QC"];

	// Draw Diagrams
	draw_diagrams(circuit_values["P"], circuit_values["QL"], circuit_values["QC"]);

	// Draw Wave Plots
	draw_waveplot_V();
	draw_waveplot_I(circuit_values["P"], Q);

	// Update stage
	stage.update();

	// Debugging
	console.log(circuit_array);


	return true;
}








function calc_values (circuit_array) {

	QL = 0;
	QC = 0;
	P = 0;

	for (i = 0; i < circuit_array.length; i++) {
		
		switch (circuit_array[i]) {
			case "1phase-motor":
				QL += config.device_1pmotor_QL; 
				QC += config.device_1pmotor_QC;
				P  += config.device_1pmotor_P;
				break;
			case "kitchen":
				QL += config.device_kitchen_QL; 
				QC += config.device_kitchen_QC;
				P  += config.device_kitchen_P;
				break;
			case "washing-machine":
				QL += config.device_washing_QL; 
				QC += config.device_washing_QC;
				P  += config.device_washing_P;
				break;
			case "capacitor":
				QL += config.device_capacitor_QL; 
				QC += config.device_capacitor_QC;
				P  += config.device_capacitor_P;
				break;
			case "capacitor2":
				QL += config.device_capacitor2_QL; 
				QC += config.device_capacitor2_QC;
				P  += config.device_capacitor2_P;
				break;
			case "capacitor3":
				QL += config.device_capacitor3_QL; 
				QC += config.device_capacitor3_QC;
				P  += config.device_capacitor3_P;
				break;
			case "coil":
				QL += config.device_coil_QL; 
				QC += config.device_coil_QC;
				P  += config.device_coil_P;
				break;
			/*
			case "3phase-motor":
				QL += config.device_3pmotor_QL; 
				QC += config.device_3pmotor_QC;
				P  += config.device_3pmotor_P;
				break;
			*/
			case "vcleaner":
				QL += config.device_vcleaner_QL; 
				QC += config.device_vcleaner_QC;
				P  += config.device_vcleaner_P;
				break;
			case "cnc":
				QL += config.device_cnc_QL; 
				QC += config.device_cnc_QC;
				P  += config.device_cnc_P;
				break;
			case "blackbox":
				QL += config.device_blackbox_QL; 
				QC += config.device_blackbox_QC;
				P  += config.device_blackbox_P;
				break;
		}

	}

	// Update Circuit Values
	var QL_rounded = Math.round(QL * 100) / 100; 	// round to 2 decimal
	var QC_rounded = Math.round(QC * 100) / 100; 	// round to 2 decimal
	var P_rounded = Math.round(P * 100) / 100;		// round to 2 decimal
	$("#circuit_values_txt").html("Q<sub>L</sub>=" + QL_rounded + " Var &nbsp; Q<sub>C</sub>=" + QC_rounded + " Var &nbsp; P=" + P_rounded + " Watt");

	// Update Diagram Label
	if (P>0) {
		var Q = QL - QC;
		var SI = P / Math.sqrt( Math.pow(P, 2) + Math.pow(Q,2) )
		var SI_rounded = Math.round(SI * 100) / 100; // round to 2 decimal
		if (SI == SI_rounded) {
			label_SI_txt.text = "Συντελεστής Ισχύος\nσυνφ = " + SI_rounded;
		} else {
			label_SI_txt.text = "Συντελεστής Ισχύος\nσυνφ ~ " + SI_rounded;
		}
		label_SI_box.visible = true;
	} else {
		label_SI_txt.text = "";
		label_SI_box.visible = false;
	}

	var results = new Array();

	results["P"] = P;
	results["QL"] = QL;
	results["QC"] = QC;

	return results;

}


function draw_diagrams(P, QL, QC) {

	var Q = QL - QC;
	// console.log ("Q=" + Q);

	// Clear if any diagram exist
	if (P == 0 && Q == 0) {
		console.log ("P=0, Q=0");
		diagram_P.graphics.clear();
		diagram_Q.graphics.clear();
		diagram_S.graphics.clear();

		label_P.text = "";
		label_Q.text = "";
		label_S.text = "";

		stage.update();

		return true;
	}


	// Define diagrams scale
	var scale = 1;
	var Ps = P;
	var Qs = Q;
	// Zoom In/Out based on Q (max width=280)
	if (Math.abs(Q) > 280) {
		scale = 280 / Math.abs(Q);
		scale = Math.round(scale * 100) / 100; // round to 2 decimal
		Ps = parseInt(P * scale);
		Qs = parseInt(Q * scale);
	} else if (Q!=0 && Math.abs(Q) < 150) {
		scale = 280 / Math.abs(Q);
		scale = Math.round(scale * 100) / 100; // round to 2 decimal
		Ps = parseInt(P * scale);
		Qs = parseInt(Q * scale);
	}
	console.log('Scale: ' + scale);

	// Zoom In/Out based on P (max height=640)
	if (Ps > 640) {
		pscale = 640 / P;
		pscale = Math.round(pscale * 100) / 100; // round to 2 decimal
		if (pscale < scale) {
			Ps = parseInt(P * pscale);
			Qs = parseInt(Q * pscale);
		}
	}

	// Draw Diagram P
	if (P > 0) {
		console.log ('Ps = ' + Ps + ', Qs= ' + Qs);
		diagram_P.graphics.clear().beginStroke("green").setStrokeStyle(3).moveTo(0, 0).lineTo(Ps, 0).endStroke();
		diagram_P.graphics.beginFill("green").setStrokeStyle(1).moveTo((Ps)-20, -8).lineTo(Ps, 0).lineTo((Ps)-20, 8).lineTo((Ps)-20, -8);

		if (Q > 0) {
			diagram_P.y = config.center_y + 250;
			label_P.y = config.center_y + 260;
		} else if (Q == 0) {
			diagram_P.y = config.center_y + 120;
			label_P.y = config.center_y + 140;
		} else if (Q < 0) {
			diagram_P.y = config.center_y + 0;
			label_P.y = config.center_y - 30;
		}
		diagram_P.x = config.center_x - parseInt(Ps/2);
		label_P.text = "Ενεργός Ισχύς P = " + P + " Watt";
	} else {
		// P = 0
		diagram_P.graphics.clear();
		label_P.text = "";
		diagram_P.x = config.center_x; // Needed if Q > 0
	}

	// Draw Diagram Q
	if (Math.abs(Q) > 0) {
		diagram_Q.graphics.clear().beginStroke("red").setStrokeStyle(3).moveTo(0, 0).lineTo(0, Qs).endStroke();
		if (Q > 0) {
			if (Qs > 20) {
				// Draw arrow
				diagram_Q.graphics.beginFill("red").setStrokeStyle(1).moveTo(-8, 20).lineTo(0, 0).lineTo(8, 20).lineTo(8, 20);
			}
			// diagram_Q.x = config.center_x + parseInt(Ps/2);	// begin at the end of P diagram
			diagram_Q.x = diagram_P.x;							// begin at the beginning of P diagram 
			diagram_Q.y = config.center_y + 250 - Qs;
			label_Q.y = config.center_y + 250 - parseInt(Qs/2);
		} else {
			if (Qs < -20) {
				// Draw arrow
				diagram_Q.graphics.beginFill("red").setStrokeStyle(1).moveTo(-8, -20).lineTo(0, 0).lineTo(8, -20).lineTo(-8, -20);
			}
			// diagram_Q.x = config.center_x + parseInt(Ps/2);	// begin at the end of P diagram
			diagram_Q.x = diagram_P.x;							// begin at the beginning of P diagram 
			diagram_Q.y = config.center_y - Qs;
			label_Q.y = config.center_y - 20 - parseInt(Qs/2);
		}
		// label_Q.x = config.center_x + parseInt(Ps/2) + 100;
		var Q_rounded = Math.round(Q * 100) / 100; // round to 2 decimal
		label_Q.x = diagram_P.x - 70;
		label_Q.text = "Άεργος Ισχύς\nQ = " + Q_rounded + " Var";
	} else {
		// Q = 0
		diagram_Q.graphics.clear();
		label_Q.text = "";
	}

	// Draw Diagram S
	if (P > 0 && Math.abs(Q) > 0) {
		var PHI = Math.atan(Qs / Ps) * 180 / Math.PI;
		// console.log("phi: " + PHI);

		diagram_S_start_x = config.center_x + parseInt(Ps/2);
		diagram_S_start_y = diagram_P.y;
		diagram_S_end_x = config.center_x - parseInt(Ps/2);
		diagram_S_end_y = diagram_Q.y;
		// console.log("S: " + diagram_S_start_y + "," + diagram_S_end_y);
		diagram_S.graphics.clear().beginStroke("black").setStrokeStyle(3).moveTo(diagram_S_start_x, diagram_S_start_y).lineTo(diagram_S_end_x, diagram_S_end_y).endStroke();
		// Draw S arrow
		// diagram_S_arrow.graphics.clear().beginFill("black").setStrokeStyle(1).moveTo(-20, -8).lineTo(0, 0).lineTo(-20, 8).lineTo(-20, -8);
		// diagram_S_arrow.regX = 0;
		// diagram_S_arrow.regY = 0;
		
		// Calculate diagram S width
		diagram_S_width = Math.pow(diagram_S_start_x - diagram_S_end_x, 2) + Math.pow(diagram_S_start_y - diagram_S_end_y, 2);
		diagram_S_width = Math.sqrt(diagram_S_width);
		// console.log("S width: " + diagram_S_width);

		// if width is too small do not show label
		if (diagram_S_width > 150) {
			// label
			if (Q > 0) {
				label_S.x = config.center_x + 20;
				label_S.y = label_Q.y - 20;
			} else {
				label_S.x = config.center_x + 20;
				label_S.y = label_Q.y + 10;
			}
			label_S.rotation = parseInt(PHI);
			// S arrow
			// diagram_S_arrow.x = diagram_S_end_x;
			// diagram_S_arrow.y = diagram_S_end_y;
			// diagram_S_arrow.rotation = - parseInt(PHI); // rotate arrow
			label_S.text = "Φαινόμενη Ισχύς S";
		} else {
			label_S.x = config.center_x - 40;
			label_S.y = label_Q.y;
			label_S.rotation = - parseInt(PHI);
			label_S.text = "S";
			// diagram_S_arrow.graphics.clear(); // hide arrow
		}
	} else if (P==0) {
		// P = 0
		diagram_S.graphics.clear();
		label_S.text = "";
		label_Q.text = "Φαινόμενη S = Άεργος Ισχύς\nQ = " + Q + " Var";
		label_Q.x = diagram_P.x - 110;
	} else if (Q==0) {
		// Q = 0
		diagram_S.graphics.clear();
		label_S.rotation = 0;
		label_S.text = "Φαινόμενη Ισχύς S = 0 VA";
		label_S.x = label_P.x;
		label_S.y = label_P.y - 60;
	} else if (P==0 && Q==0) {
		diagram_S.graphics.clear();
		label_S.text = "";
	}

	// calcuate phi
	var PHI = Math.atan(Q / P) * 180 / Math.PI;
	console.log ('phi=' + PHI);

	// Draw Phi angle
	if (Ps > 100 && PHI != 90 && PHI != -90) {
		PHIangle.x = diagram_P.x + parseInt(Ps);
		PHIangle.y = diagram_P.y;

		PHIangle.graphics.clear().beginFill("rgba(204, 204, 204, 0.32)").beginStroke("grey").setStrokeStyle(1).arc(0, 0, 50, 0, -PHI * Math.PI / 180, PHI>0).lineTo(0, 0).closePath();
		PHIangle.rotation = 180 + PHI;
		stage.addChild(PHIangle);
	} else {
		PHIangle.graphics.clear();
	}

	// Draw phi text
	if (Ps > 100 && (PHI > 15 || PHI < -15)) {
		PHItext.x = diagram_P.x + parseInt(Ps) - 65;

		// var PHIy;

		if (PHI > 0) {
			// PHIy = 350 - 40 * Math.sin (PHI * Math.PI / 180);
			PHItext.y = diagram_P.y - (Math.abs(Qs) * 0.1);
		} else {
			// PHIy = 350 - 12 * Math.sin (PHI * Math.PI / 180);
			PHItext.y = diagram_P.y + (Math.abs(Qs) * 0.03);
		}

		console.log('phi (x,y): ' + PHItext.x + ',' + PHItext.y);

		PHItext.text = "φ";
		stage.addChild(PHItext);
	} else {
		PHItext.text = "";
	}


	stage.update();

	return true;

}



function draw_waveplot_V () {

	// Configuration
	var Vp = 230; 		// Peak Voltage
 	var fo = 50; 		// Frequency
 	var phase = 0;		// Phase
 	var Vmax = 300; 	// Voltage max
 	var Tmax = 0.04;	// Time max
 	var N = 200;		// Number of points

 	var canvas_width = 1000;
 	var canvas_height = 350;

	var axes={};

	// x,y plotting variables
	var x = new Array();
	var y = new Array();

	var i, x0, y0, xscale, yscale, xp, yp;

	// define plot paramaters
	tstart = -Tmax;
	tstop = Tmax;
	dt = (tstop - tstart) / (N - 1);				// time increment over N points
	
	axes.xscale = canvas_width / (2 * Tmax); 		// x pix per s
	axes.yscale = canvas_height / (2 * Vmax);   	// y pix per V
	axes.N = N;

	// create function 
	for (i = 0; i < N; i++) {
	 	x[i] = tstart + i * dt;
	 	y[i] = Vp * Math.sin(2 * Math.PI * fo * x[i] + phase * Math.PI / 180);
	}
	
	// define origin at plot center
	axes.x0 = 0.5 + 0.5 * canvas_width;  // x0, y0 place plot origin in middle of canvas
	axes.y0 = 0.5 + 0.5 * canvas_height;
	  
	x0 = axes.x0;
	y0 = axes.y0;
	xscale = axes.xscale;
	yscale = axes.yscale;

	v_plot.graphics.clear().beginStroke("blue").setStrokeStyle(2);


	for (i=0; i < axes.N; i++) {
	 	// translate actual x,y to plot xp,yp
	 	xp = x0 + x[i] * xscale;
	 	yp = y0 - y[i] * yscale;
	 	
	 	// draw line to next point
		if (i==0) {
			v_plot.graphics.moveTo(xp, yp);
			stage.update();
		} else {
			v_plot.graphics.lineTo(xp, yp);
			stage.update();
		}
		// console.log ("xp: " + xp + ", yp: " + yp);
	}
	
	v_plot.graphics.endStroke();

	// Move Plot to the correct position
	v_plot.x = config.center_x - 500;
	v_plot.y = config.center_y - 55;

	return true;

}

function draw_waveplot_I (P, Q) {

	// Configuration
	var Vp = 180; 		// Peak Voltage
 	var fo = 50; 		// Frequency
 	var phase = 0;		// Phase
 	var Vmax = 300; 	// Voltage max
 	var Tmax = 0.04;	// Time max
 	var N = 200;		// Number of points

 	var canvas_width = 1000;
 	var canvas_height = 350;

	var axes={};

	// x,y plotting variables
	var x = new Array();
	var y = new Array();

	var i, x0, y0, xscale, yscale, xp, yp;

	if (P == 0 && Q == 0) {
		//axe_x.visible = false;
		//axe_y.visible = false;
		v_plot.graphics.clear();
		i_plot.graphics.clear();

		return true;

	} else {
		//axe_x.visible = true;
		//axe_y.visible = true;
	}

	/*
	if (P == 0 && Q > 0) {
		phase = 90;
	} else if (P == 0 && Q < 0 ) {
		phase = -90;
	} else if (P > 0 && Q > 0) {
		phase = Math.atan(Q / P) * 180 / Math.PI;
	} else if (P > 0 && Q < 0) {
		phase = - (Math.atan(Q / P) * 180 / Math.PI);
	}
	*/

	if (P==0) {
		if (Q > 0) {
			phase = - 90;
		} else if (Q < 0) {
			phase = 90;
		}
	} else if (P > 0) {
		if (Q > 0) {
			phase = - ( Math.atan(Q / P) * 180 / Math.PI );
		} else if (Q < 0) {
			phase = - ( Math.atan(Q / P) * 180 / Math.PI );
		}	
	}



	// define plot paramaters
	tstart = -Tmax;
	tstop = Tmax;
	dt = (tstop - tstart) / (N - 1);				// time increment over N points
	
	axes.xscale = canvas_width / (2 * Tmax); 		// x pix per s
	axes.yscale = canvas_height / (2 * Vmax);   	// y pix per V
	axes.N = N;

	// create function 
	for (i = 0; i < N; i++) {
	 	x[i] = tstart + i * dt;
	 	y[i] = Vp * Math.sin(2 * Math.PI * fo * x[i] + phase * Math.PI / 180);
	}
	
	// define origin at plot center
	axes.x0 = 0.5 + 0.5 * canvas_width;  // x0, y0 place plot origin in middle of canvas
	axes.y0 = 0.5 + 0.5 * canvas_height;
	  
	x0 = axes.x0;
	y0 = axes.y0;
	xscale = axes.xscale;
	yscale = axes.yscale;

	i_plot.graphics.clear().beginStroke("red").setStrokeStyle(2);


	for (i=0; i < axes.N; i++) {
	 	// translate actual x,y to plot xp,yp
	 	xp = x0 + x[i] * xscale;
	 	yp = y0 - y[i] * yscale;
	 	
	 	// draw line to next point
		if (i==0) {
			i_plot.graphics.moveTo(xp, yp);
			stage.update();
		} else {
			i_plot.graphics.lineTo(xp, yp);
			stage.update();
		}
		// console.log ("xp: " + xp + ", yp: " + yp);
	}
	
	i_plot.graphics.endStroke();

	// Move Plot to the correct position
	i_plot.x = config.center_x - 500;
	i_plot.y = config.center_y - 55;

	return true;

}

