/* --------------------------------------------------
Author: Anastasios Pallas / tcpallas@gmail.com
Version 3.2
Last Update: 2018-11-22
-------------------------------------------------- */

// Initialize Canvas
var canvas = document.getElementById("canvas");
var context = canvas.getContext('2d');
var stage = new createjs.Stage("canvas");

// Theory buttons
var theory_btn_img = new Image();
theory_btn_img.src = 'images/theory-buttons.png';

var theory_btn = new createjs.Bitmap(theory_btn_img);
theory_btn.scaleX = theory_btn.scaleY = 1;
theory_btn.x = config.center_x - 530;
theory_btn.y = config.center_y - 310;

theory_btn_img.onload = function () {
	stage.addChild(theory_btn);
	stage.setChildIndex(theory_btn, 0);
	stage.update();
}

// Circuit Title
var pick_device_title = new createjs.Text();
pick_device_title.text = config.pick_device_title;
pick_device_title.font = "18px Arial";
pick_device_title.color = "#006699";
pick_device_title.textAlign = "left";

pick_device_title.x = config.center_x - 460;
pick_device_title.y = config.center_y - 340;
stage.addChild(pick_device_title);

var circuit_tab1_text = new createjs.Text();
circuit_tab1_text.text = config.circuit_tab1_text;
circuit_tab1_text.font = "17px Arial";
circuit_tab1_text.color = "#ffffff";
circuit_tab1_text.textAlign = "left";

circuit_tab1_text.x = config.center_x + 60;
circuit_tab1_text.y = config.center_y - 112;
stage.addChild(circuit_tab1_text);

var circuit_tab2_text = new createjs.Text();
circuit_tab2_text.text = config.circuit_tab2_text;
circuit_tab2_text.font = "17px Arial";
circuit_tab2_text.color = "#00aeef";
circuit_tab2_text.textAlign = "left";

circuit_tab2_text.x = config.center_x + 180;
circuit_tab2_text.y = config.center_y - 112;
stage.addChild(circuit_tab2_text);

var circuit_tab3_text = new createjs.Text();
circuit_tab3_text.text = config.circuit_tab3_text;
circuit_tab3_text.font = "17px Arial";
circuit_tab3_text.color = "#00aeef";
circuit_tab3_text.textAlign = "left";

circuit_tab3_text.x = config.center_x + 340;
circuit_tab3_text.y = config.center_y - 112;
stage.addChild(circuit_tab3_text);






// Pick device background image
var device_bg_img = new Image();
device_bg_img.src = 'images/device-bg.png';

var device_bg = new createjs.Bitmap(device_bg_img);
device_bg.scaleX = device_bg.scaleY = 1;
device_bg.x = config.center_x - 470;
device_bg.y = config.center_y - 310;

device_bg_img.onload = function () {
	stage.addChild(device_bg);
	stage.setChildIndex(device_bg, 0);
	stage.update();
}




// DEVICES

// One Phase Motor
var device_1pmotor_img = new Image();
device_1pmotor_img.src = 'images/device-1phase-motor.png';

var device_1pmotor = new createjs.Bitmap(device_1pmotor_img);
device_1pmotor.scaleX = device_1pmotor.scaleY = 1;
device_1pmotor.x = config.center_x - 460;
device_1pmotor.y = config.center_y - 275;

device_1pmotor_img.onload = function () {
	stage.addChild(device_1pmotor);
	stage.setChildIndex(device_1pmotor, 10);
	stage.update();
}

// Kitchen
var device_kitchen_img = new Image();
device_kitchen_img.src = 'images/device-kitchen.png';

var device_kitchen = new createjs.Bitmap(device_kitchen_img);
device_kitchen.scaleX = device_kitchen.scaleY = 1;
device_kitchen.x = config.center_x - 460;
device_kitchen.y = config.center_y - 275;

device_kitchen_img.onload = function () {
	stage.addChild(device_kitchen);
	stage.setChildIndex(device_kitchen, 10);
	stage.update();
}

// Washing Machine
var device_washing_img = new Image();
device_washing_img.src = 'images/device-washing-machine.png';

var device_washing = new createjs.Bitmap(device_washing_img);
device_washing.scaleX = device_washing.scaleY = 1;
device_washing.x = config.center_x - 460;
device_washing.y = config.center_y - 275;

device_washing_img.onload = function () {
	stage.addChild(device_washing);
	stage.setChildIndex(device_washing, 10);
	stage.update();
}

// 3 Capacitors
var device_capacitor_img = new Image();
device_capacitor_img.src = 'images/device-capacitor.png';

var device_capacitor = new createjs.Bitmap(device_capacitor_img);
device_capacitor.scaleX = device_capacitor.scaleY = 1;
device_capacitor.x = config.center_x - 460;
device_capacitor.y = config.center_y - 275;

device_capacitor_img.onload = function () {
	stage.addChild(device_capacitor);
	stage.setChildIndex(device_capacitor, 10);
	stage.update();
}


var device_capacitor2_img = new Image();
device_capacitor2_img.src = 'images/device-capacitor2.png';

var device_capacitor2 = new createjs.Bitmap(device_capacitor2_img);
device_capacitor2.scaleX = device_capacitor2.scaleY = 1;
device_capacitor2.x = config.center_x - 460;
device_capacitor2.y = config.center_y - 275;

device_capacitor2_img.onload = function () {
	stage.addChild(device_capacitor2);
	stage.setChildIndex(device_capacitor2, 10);
	stage.update();
}

var device_capacitor3_img = new Image();
device_capacitor3_img.src = 'images/device-capacitor3.png';

var device_capacitor3 = new createjs.Bitmap(device_capacitor3_img);
device_capacitor3.scaleX = device_capacitor2.scaleY = 1;
device_capacitor3.x = config.center_x - 460;
device_capacitor3.y = config.center_y - 275;

device_capacitor3_img.onload = function () {
	stage.addChild(device_capacitor3);
	stage.setChildIndex(device_capacitor3, 10);
	stage.update();
}

// Coil
var device_coil_img = new Image();
device_coil_img.src = 'images/device-coil.png';

var device_coil = new createjs.Bitmap(device_coil_img);
device_coil.scaleX = device_coil.scaleY = 1;
device_coil.x = config.center_x - 460;
device_coil.y = config.center_y - 275;

device_coil_img.onload = function () {
	stage.addChild(device_coil);
	stage.setChildIndex(device_coil, 10);
	stage.update();
}

/*
// Three Phase Motor
var device_3pmotor_img = new Image();
device_3pmotor_img.src = 'images/device-3phase-motor.png';

var device_3pmotor = new createjs.Bitmap(device_3pmotor_img);
device_3pmotor.scaleX = device_3pmotor.scaleY = 1;
device_3pmotor.x = config.center_x - 460;
device_3pmotor.y = config.center_y - 275;

device_3pmotor_img.onload = function () {
	stage.addChild(device_3pmotor);
	stage.setChildIndex(device_3pmotor, 10);
	stage.update();
}
*/

// Vacuum cleaner
var device_vcleaner_img = new Image();
device_vcleaner_img.src = 'images/device-vcleaner.png';

var device_vcleaner = new createjs.Bitmap(device_vcleaner_img);
device_vcleaner.scaleX = device_vcleaner.scaleY = 1;
device_vcleaner.x = config.center_x - 460;
device_vcleaner.y = config.center_y - 275;

device_vcleaner_img.onload = function () {
	stage.addChild(device_vcleaner);
	stage.setChildIndex(device_vcleaner, 10);
	stage.update();
}

// CNC
var device_cnc_img = new Image();
device_cnc_img.src = 'images/device-cnc.png';

var device_cnc = new createjs.Bitmap(device_cnc_img);
device_cnc.scaleX = device_cnc.scaleY = 1;
device_cnc.x = config.center_x - 460;
device_cnc.y = config.center_y - 275;

device_cnc_img.onload = function () {
	stage.addChild(device_cnc);
	stage.setChildIndex(device_cnc, 10);
	stage.update();
}

// Black box
var device_blackbox_img = new Image();
device_blackbox_img.src = 'images/device-blackbox.png';

var device_blackbox = new createjs.Bitmap(device_blackbox_img);
device_blackbox.scaleX = device_blackbox.scaleY = 1;
device_blackbox.x = config.center_x - 460;
device_blackbox.y = config.center_y - 275;

device_blackbox_img.onload = function () {
	stage.addChild(device_blackbox);
	stage.setChildIndex(device_blackbox, 10);
	stage.update();
}


// DEVICE CIRCUITS


// RLC
var device_circuit_RLC_img = new Image();
device_circuit_RLC_img.src = 'images/device-circuit-RLC.png';

var device_circuit_RLC = new createjs.Bitmap(device_circuit_RLC_img);
device_circuit_RLC.scaleX = device_circuit_RLC.scaleY = 1;
device_circuit_RLC.x = config.center_x - 250;
device_circuit_RLC.y = config.center_y - 275;

device_circuit_RLC_img.onload = function () {
	stage.addChild(device_circuit_RLC);
	stage.setChildIndex(device_circuit_RLC, 10);
	stage.update();
}


// RL
var device_circuit_RL_img = new Image();
device_circuit_RL_img.src = 'images/device-circuit-RL.png';

var device_circuit_RL = new createjs.Bitmap(device_circuit_RL_img);
device_circuit_RL.scaleX = device_circuit_RL.scaleY = 1;
device_circuit_RL.x = config.center_x - 250;
device_circuit_RL.y = config.center_y - 275;

device_circuit_RL_img.onload = function () {
	stage.addChild(device_circuit_RL);
	stage.setChildIndex(device_circuit_RL, 10);
	stage.update();
}

// RC
var device_circuit_RC_img = new Image();
device_circuit_RC_img.src = 'images/device-circuit-RC.png';

var device_circuit_RC = new createjs.Bitmap(device_circuit_RC_img);
device_circuit_RC.scaleX = device_circuit_RC.scaleY = 1;
device_circuit_RC.x = config.center_x - 250;
device_circuit_RC.y = config.center_y - 275;

device_circuit_RC_img.onload = function () {
	stage.addChild(device_circuit_RC);
	stage.setChildIndex(device_circuit_RC, 10);
	stage.update();
}


// R
var device_circuit_R_img = new Image();
device_circuit_R_img.src = 'images/device-circuit-R.png';

var device_circuit_R = new createjs.Bitmap(device_circuit_R_img);
device_circuit_R.scaleX = device_circuit_R.scaleY = 1;
device_circuit_R.x = config.center_x - 250;
device_circuit_R.y = config.center_y - 275;

device_circuit_R_img.onload = function () {
	stage.addChild(device_circuit_R);
	stage.setChildIndex(device_circuit_R, 10);
	stage.update();
}

// C
var device_circuit_C_img = new Image();
device_circuit_C_img.src = 'images/device-circuit-C.png';

var device_circuit_C = new createjs.Bitmap(device_circuit_C_img);
device_circuit_C.scaleX = device_circuit_C.scaleY = 1;
device_circuit_C.x = config.center_x - 250;
device_circuit_C.y = config.center_y - 275;

device_circuit_C_img.onload = function () {
	stage.addChild(device_circuit_C);
	stage.setChildIndex(device_circuit_C, 10);
	stage.update();
}

// L
var device_circuit_L_img = new Image();
device_circuit_L_img.src = 'images/device-circuit-L.png';

var device_circuit_L = new createjs.Bitmap(device_circuit_L_img);
device_circuit_L.scaleX = device_circuit_L.scaleY = 1;
device_circuit_L.x = config.center_x - 250;
device_circuit_L.y = config.center_y - 275;

device_circuit_L_img.onload = function () {
	stage.addChild(device_circuit_L);
	stage.setChildIndex(device_circuit_L, 10);
	stage.update();
}

// Blackbox circuit
var device_circuit_blackbox_img = new Image();
device_circuit_blackbox_img.src = 'images/device-circuit-blackbox.png';

var device_circuit_blackbox = new createjs.Bitmap(device_circuit_blackbox_img);
device_circuit_blackbox.scaleX = device_circuit_blackbox.scaleY = 1;
device_circuit_blackbox.x = config.center_x - 250;
device_circuit_blackbox.y = config.center_y - 275;

device_circuit_blackbox_img.onload = function () {
	stage.addChild(device_circuit_blackbox);
	stage.setChildIndex(device_circuit_blackbox, 10);
	stage.update();
}





// MAIN CIRCUIT BACKGROUND IMAGE
var circuit_bg_img = new Image();
circuit_bg_img.src = 'images/main-circuit-bg.png';

var circuit_bg = new createjs.Bitmap(circuit_bg_img);
circuit_bg.scaleX = circuit_bg.scaleY = 1;
circuit_bg.x = config.center_x - 530;
circuit_bg.y = config.center_y - 90;

circuit_bg_img.onload = function () {
	stage.addChild(circuit_bg);
	stage.setChildIndex(circuit_bg, 5);
	stage.update();
}

// Circuit Labels based on positions
var circuit_label1 = new createjs.Text();
circuit_label1.text = "";
circuit_label1.font = "15px Arial";
circuit_label1.color = "#00aeef";
circuit_label1.textAlign = "center";
circuit_label1.x = config.center_x - 370;
circuit_label1.y = config.center_y - 60;
stage.addChild(circuit_label1);
stage.setChildIndex(circuit_label1, 10);

var circuit_label2 = new createjs.Text();
circuit_label2.text = "";
circuit_label2.font = "15px Arial";
circuit_label2.color = "#00aeef";
circuit_label2.textAlign = "center";
circuit_label2.x = config.center_x - 175;
circuit_label2.y = config.center_y - 60;
stage.addChild(circuit_label2);
stage.setChildIndex(circuit_label2, 10);

var circuit_label3 = new createjs.Text();
circuit_label3.text = "";
circuit_label3.font = "15px Arial";
circuit_label3.color = "#00aeef";
circuit_label3.textAlign = "center";
circuit_label3.x = config.center_x + 20;
circuit_label3.y = config.center_y - 60;
stage.addChild(circuit_label3);
stage.setChildIndex(circuit_label3, 10);

var circuit_label4 = new createjs.Text();
circuit_label4.text = "";
circuit_label4.font = "15px Arial";
circuit_label4.color = "#00aeef";
circuit_label4.textAlign = "center";
circuit_label4.x = config.center_x + 215;
circuit_label4.y = config.center_y - 60;
stage.addChild(circuit_label4);
stage.setChildIndex(circuit_label4, 10);

var circuit_label5 = new createjs.Text();
circuit_label5.text = "";
circuit_label5.font = "15px Arial";
circuit_label5.color = "#00aeef";
circuit_label5.textAlign = "center";
circuit_label5.x = config.center_x + 410;
circuit_label5.y = config.center_y - 60;
stage.addChild(circuit_label5);
stage.setChildIndex(circuit_label5, 10);




// Main Circuit Tab
var circuit_tab1 = new createjs.Shape();
circuit_tab1.graphics.beginFill("#00aeef").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 120, 40, 10);
circuit_tab1.x = config.center_x + 35;
circuit_tab1.y = config.center_y - 120;
circuit_tab1.cursor = "";
stage.addChild(circuit_tab1);
stage.setChildIndex(circuit_tab1, 0);

// Diagram QP Tab
var circuit_tab2 = new createjs.Shape();
circuit_tab2.graphics.beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);
circuit_tab2.x = config.center_x + 155;
circuit_tab2.y = config.center_y - 120;
circuit_tab2.cursor = "pointer";
stage.addChild(circuit_tab2);
stage.setChildIndex(circuit_tab2, 0);

var tab2_overlay = new createjs.Shape();
tab2_overlay.graphics.beginFill("white").drawRoundRect(0, 0, 1040, 370, 10);
tab2_overlay.x = config.center_x - 520;
tab2_overlay.y = config.center_y - 80;
stage.addChild(tab2_overlay);
stage.update();


// Diagram VI Tab
var circuit_tab3 = new createjs.Shape();
circuit_tab3.graphics.beginFill("#d1f2ff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 170, 40, 10);
circuit_tab3.x = config.center_x + 325;
circuit_tab3.y = config.center_y - 120;
circuit_tab3.cursor = "pointer";
stage.addChild(circuit_tab3);
stage.setChildIndex(circuit_tab3, 0);

var tab3_overlay = new createjs.Shape();
tab3_overlay.graphics.beginFill("white").drawRoundRect(0, 0, 1040, 370, 10);
tab3_overlay.x = config.center_x - 520;
tab3_overlay.y = config.center_y - 80;
stage.addChild(tab3_overlay);
stage.update();


// Circuit Values
var circuit_values_bg = new createjs.Shape();
circuit_values_bg.graphics.beginFill("#ffffff").beginStroke("#00aeef").setStrokeStyle(3).drawRoundRect(0, 0, 400, 50, 10);
circuit_values_bg.x = config.center_x + 100;
circuit_values_bg.y = config.center_y + 295;
stage.addChild(circuit_values_bg);
stage.setChildIndex(circuit_values_bg, 300);
stage.update();

/*
var circuit_values_txt = new createjs.Text();
circuit_values_txt.text = "";
circuit_values_txt.font = "18px Arial";
circuit_values_txt.color = "#006699";
circuit_values_txt.textAlign = "center";

circuit_values_txt.x = config.center_x + 330;
circuit_values_txt.y = config.center_y + 310;
stage.addChild(circuit_values_txt);
stage.setChildIndex(circuit_values_txt, 300);
stage.update();
*/




// Blackbox Graphics/Text
// Bubble background image
var blackbox_bubble_img = new Image();
blackbox_bubble_img.src = 'images/blackbox-bubble.png';

var blackbox_bubble = new createjs.Bitmap(blackbox_bubble_img);
blackbox_bubble.scaleX = circuit_bg.scaleY = 1;
blackbox_bubble.x = config.center_x - 60;
blackbox_bubble.y = config.center_y - 295;

blackbox_bubble_img.onload = function () {
	stage.addChild(blackbox_bubble);
	stage.setChildIndex(blackbox_bubble, 0);
	stage.update();
}

var blackbox_ampmeter_txt = new createjs.Text();
blackbox_ampmeter_txt.text = "I=0 A";
blackbox_ampmeter_txt.font = "18px Arial";
blackbox_ampmeter_txt.color = "#006699";
blackbox_ampmeter_txt.textAlign = "center";

blackbox_ampmeter_txt.x = config.center_x - 370;
blackbox_ampmeter_txt.y = config.center_y + 52;
stage.addChild(blackbox_ampmeter_txt);
stage.setChildIndex(blackbox_ampmeter_txt, 300);
stage.update();




// Circuit: Blank
var circuit_add_img = new Image();
circuit_add_img.src = 'images/circuit-add.png';

var circuit_add = new createjs.Bitmap(circuit_add_img);
circuit_add.scaleX = circuit_add.scaleY = 1;
circuit_add.x = config.center_x - 460;	// - 460, - 265, - 70, + 125, + 320
circuit_add.y = config.center_y - 25;

circuit_add_img.onload = function () {
	stage.addChild(circuit_add);
	stage.setChildIndex(circuit_add, 100);
	stage.update();
}


// Circuit R
var circuit_R_img = new Image();
circuit_R_img.src = 'images/circuit-R.png';

var circuit_R = new createjs.Bitmap(circuit_R_img);
circuit_R.scaleX = circuit_R.scaleY = 1;
circuit_R.x = config.center_x - 460;	// - 460, - 265, - 70, + 125, + 320
circuit_R.y = config.center_y - 25;

circuit_R_img.onload = function () {
	stage.addChild(circuit_R);
	stage.setChildIndex(circuit_R, 100);
	stage.update();
}

var circuit_R2 = circuit_R.clone();
circuit_R2.x = config.center_x - 265;
stage.addChild(circuit_R2);
stage.setChildIndex(circuit_R2, 100);
stage.update();

var circuit_R3 = circuit_R.clone();
circuit_R3.x = config.center_x - 70;
stage.addChild(circuit_R3);
stage.setChildIndex(circuit_R3, 100);
var circuit_R4 = circuit_R.clone();
circuit_R4.x = config.center_x + 125;
stage.addChild(circuit_R4);
stage.setChildIndex(circuit_R4, 100);
var circuit_R5 = circuit_R.clone();
circuit_R5.x = config.center_x + 320;
stage.addChild(circuit_R5);
stage.setChildIndex(circuit_R5, 100);

stage.update();

// Circuit L
var circuit_L_img = new Image();
circuit_L_img.src = 'images/circuit-L.png';

var circuit_L = new createjs.Bitmap(circuit_L_img);
circuit_L.scaleX = circuit_L.scaleY = 1;
circuit_L.x = config.center_x - 460;	// - 460, - 265, - 70, + 125, + 320
circuit_L.y = config.center_y - 25;

circuit_L_img.onload = function () {
	stage.addChild(circuit_L);
	stage.setChildIndex(circuit_L, 100);
	stage.update();
}

var circuit_L2 = circuit_L.clone();
circuit_L2.x = config.center_x - 265;
stage.addChild(circuit_L2);
stage.setChildIndex(circuit_L2, 100);
var circuit_L3 = circuit_L.clone();
circuit_L3.x = config.center_x - 70;
stage.addChild(circuit_L3);
stage.setChildIndex(circuit_L3, 100);
var circuit_L4 = circuit_L.clone();
circuit_L4.x = config.center_x + 125;
stage.addChild(circuit_L4);
stage.setChildIndex(circuit_L4, 100);
var circuit_L5 = circuit_L.clone();
circuit_L5.x = config.center_x + 320;
stage.addChild(circuit_L5);
stage.setChildIndex(circuit_L5, 100);


// Circuit C
var circuit_C_img = new Image();
circuit_C_img.src = 'images/circuit-C.png';

var circuit_C = new createjs.Bitmap(circuit_C_img);
circuit_C.scaleX = circuit_C.scaleY = 1;
circuit_C.x = config.center_x - 460;	// - 460, - 265, - 70, + 125, + 320
circuit_C.y = config.center_y - 25;

circuit_C_img.onload = function () {
	stage.addChild(circuit_C);
	stage.setChildIndex(circuit_C, 100);
	stage.update();
}

var circuit_C2 = circuit_C.clone();
circuit_C2.x = config.center_x - 265;
stage.addChild(circuit_C2);
stage.setChildIndex(circuit_C2, 100);
var circuit_C3 = circuit_C.clone();
circuit_C3.x = config.center_x - 70;
stage.addChild(circuit_C3);
stage.setChildIndex(circuit_C3, 100);
var circuit_C4 = circuit_C.clone();
circuit_C4.x = config.center_x + 125;
stage.addChild(circuit_C4);
stage.setChildIndex(circuit_C4, 100);
var circuit_C5 = circuit_C.clone();
circuit_C5.x = config.center_x + 320;
stage.addChild(circuit_C5);
stage.setChildIndex(circuit_C5, 100);



// Circuit RL
var circuit_RL_img = new Image();
circuit_RL_img.src = 'images/circuit-RL.png';

var circuit_RL = new createjs.Bitmap(circuit_RL_img);
circuit_RL.scaleX = circuit_RL.scaleY = 1;
circuit_RL.x = config.center_x - 460;	// - 460, - 265, - 70, + 125, + 320
circuit_RL.y = config.center_y - 25;

circuit_RL_img.onload = function () {
	stage.addChild(circuit_RL);
	stage.setChildIndex(circuit_RL, 100);
	stage.update();
}

var circuit_RL2 = circuit_RL.clone();
circuit_RL2.x = config.center_x - 265;
stage.addChild(circuit_RL2);
stage.setChildIndex(circuit_RL2, 100);
var circuit_RL3 = circuit_RL.clone();
circuit_RL3.x = config.center_x - 70;
stage.addChild(circuit_RL3);
stage.setChildIndex(circuit_RL3, 100);
var circuit_RL4 = circuit_RL.clone();
circuit_RL4.x = config.center_x + 125;
stage.addChild(circuit_RL4);
stage.setChildIndex(circuit_RL4, 100);
var circuit_RL5 = circuit_RL.clone();
circuit_RL5.x = config.center_x + 320;
stage.addChild(circuit_RL5);
stage.setChildIndex(circuit_RL5, 100);


/*
// Circuit RC
var circuit_RC_img = new Image();
circuit_RC_img.src = 'images/circuit-RC.png';

var circuit_RC = new createjs.Bitmap(circuit_RC_img);
circuit_RC.scaleX = circuit_RC.scaleY = 1;
circuit_RC.x = config.center_x - 460;	// - 460, - 265, - 70, + 125, + 320
circuit_RC.y = config.center_y - 25;

circuit_RC_img.onload = function () {
	stage.addChild(circuit_RC);
	stage.setChildIndex(circuit_RC, 100);
	stage.update();
}
*/


// Circuit RLC
var circuit_RLC_img = new Image();
circuit_RLC_img.src = 'images/circuit-RLC.png';

var circuit_RLC = new createjs.Bitmap(circuit_RLC_img);
circuit_RLC.scaleX = circuit_RLC.scaleY = 1;
circuit_RLC.x = config.center_x - 460;
circuit_RLC.y = config.center_y - 25;

circuit_RLC_img.onload = function () {
	stage.addChild(circuit_RLC);
	stage.setChildIndex(circuit_RLC, 100);
	stage.update();
}

var circuit_RLC2 = circuit_RLC.clone();
circuit_RLC2.x = config.center_x - 265;
stage.addChild(circuit_RLC2);
stage.setChildIndex(circuit_RLC2, 100);
var circuit_RLC3 = circuit_RLC.clone();
circuit_RLC3.x = config.center_x - 70;
stage.addChild(circuit_RLC3);
stage.setChildIndex(circuit_RLC3, 100);
var circuit_RLC4 = circuit_RLC.clone();
circuit_RLC4.x = config.center_x + 125;
stage.addChild(circuit_RLC4);
stage.setChildIndex(circuit_RLC4, 100);
var circuit_RLC5 = circuit_RLC.clone();
circuit_RLC5.x = config.center_x + 320;
stage.addChild(circuit_RLC5);
stage.setChildIndex(circuit_RLC5, 100);


stage.update();




// Circuit Blackbox
var circuit_blackbox_img = new Image();
circuit_blackbox_img.src = 'images/circuit-blackbox.png';

var circuit_blackbox = new createjs.Bitmap(circuit_blackbox_img);
circuit_blackbox.scaleX = circuit_blackbox.scaleY = 1;
circuit_blackbox.x = config.center_x - 460;	// - 460, - 265, - 70, + 125, + 320
circuit_blackbox.y = config.center_y - 25;

circuit_blackbox_img.onload = function () {
	stage.addChild(circuit_blackbox);
	stage.setChildIndex(circuit_blackbox, 100);
	stage.update();
}








// Draw Diagrams
var diagram_P = new createjs.Shape();
stage.addChild(diagram_P);

var diagram_Q = new createjs.Shape();
stage.addChild(diagram_Q);

var diagram_S = new createjs.Shape();
stage.addChild(diagram_S);

// var diagram_S_arrow = new createjs.Shape();
// stage.addChild(diagram_S_arrow);

// Create Phi angle
var PHIangle = new createjs.Shape();
var PHItext = new createjs.Text();
PHItext.text = "";
PHItext.font = "16px Arial";
PHItext.color = "grey";
PHItext.textAlign = "center";
PHItext.x = config.center_x;
PHItext.y = config.center_y;
stage.addChild(PHItext);

// Diagram Labels
var label_P = new createjs.Text();
label_P.text = "";
label_P.font = "16px Arial";
label_P.color = "green";
label_P.textAlign = "center";

label_P.x = config.center_x + 0;
label_P.y = config.center_y + 260;
stage.addChild(label_P);

var label_Q = new createjs.Text();
label_Q.text = "";
label_Q.font = "16px Arial";
label_Q.lineHeight = "20";
label_Q.color = "red";
label_Q.textAlign = "center";

label_Q.x = config.center_x + 0;
label_Q.y = config.center_y + 260;
stage.addChild(label_Q);

var label_S = new createjs.Text();
label_S.text = "";
label_S.font = "16px Arial";
label_S.color = "black";
label_S.textAlign = "center";

label_S.x = config.center_x + 0;
label_S.y = config.center_y + 260;
stage.addChild(label_S);

var label_SI_box = new createjs.Shape();
label_SI_box.graphics.beginStroke("#006699").beginFill("#f5f5f5").drawRoundRect(0, 0, 150, 56, 5).endFill();
label_SI_box.x = config.center_x + 355;
label_SI_box.y = config.center_y - 65;

var label_SI_txt = new createjs.Text();
label_SI_txt.text = "Συντελεστής Ισχύος\nσυνφ = ";
label_SI_txt.font = "15px Arial";
label_SI_txt.lineHeight = "20";
label_SI_txt.color = "#006699";
label_SI_txt.textAlign = "center";
label_SI_txt.x = config.center_x + 430;
label_SI_txt.y = config.center_y - 55;


var label_SI = new createjs.Container();
label_SI.addChild(label_SI_box);
label_SI.addChild(label_SI_txt);

stage.addChild(label_SI);



// Draw Waveplot Axes
var axe_x = new createjs.Shape();
axe_x.graphics.beginStroke("grey").setStrokeStyle(1).moveTo(0, 0).lineTo(1000, 0).endStroke();
axe_x.x = config.center_x - 500;
axe_x.y = config.center_y + 120;

var axe_y = new createjs.Shape();
axe_y.graphics.beginStroke("grey").setStrokeStyle(1).moveTo(0, 0).lineTo(0, 350).endStroke();
axe_y.x = config.center_x + 0;
axe_y.y = config.center_y - 60;

var label_axe_y = new createjs.Text();
label_axe_y.text = "v(t), i(t)";
label_axe_y.font = "16px Arial";
label_axe_y.color = "grey";
label_axe_y.textAlign = "center";
label_axe_y.x = config.center_x - 30;
label_axe_y.y = config.center_y - 55;

var label_axe_x = new createjs.Text();
label_axe_x.text = "ωt";
label_axe_x.font = "16px Arial";
label_axe_x.color = "grey";
label_axe_x.textAlign = "center";
label_axe_x.x = config.center_x + 480;
label_axe_x.y = config.center_y + 125;

var plot_axes = new createjs.Container();
plot_axes.addChild(axe_x);
plot_axes.addChild(axe_y);
plot_axes.addChild(label_axe_y);
plot_axes.addChild(label_axe_x);

stage.addChild(plot_axes);


var v_plot = new createjs.Shape();
v_plot.graphics.beginStroke("blue").setStrokeStyle(2);
stage.addChild(v_plot);

var i_plot = new createjs.Shape();
i_plot.graphics.beginStroke("red").setStrokeStyle(2);
stage.addChild(i_plot);

var label_V = new createjs.Shape();
label_V.graphics.beginStroke("blue").setStrokeStyle(2).moveTo(0, 0).lineTo(50, 0).endStroke();
label_V.x = config.center_x + 440;
label_V.y = config.center_y - 45;

var label_I = new createjs.Shape();
label_I.graphics.beginStroke("red").setStrokeStyle(2).moveTo(0, 0).lineTo(50, 0).endStroke();
label_I.x = config.center_x + 440;
label_I.y = config.center_y - 25;

var label_VI_box = new createjs.Shape();
label_VI_box.graphics.beginStroke("#006699").beginFill("#f5f5f5").drawRoundRect(0, 0, 140, 56, 5).endFill();
label_VI_box.x = config.center_x + 365;
label_VI_box.y = config.center_y - 65;

var label_V_txt = new createjs.Text();
label_V_txt.text = "Τάση V";
label_V_txt.font = "14px Arial";
label_V_txt.color = "#006699";
label_V_txt.textAlign = "right";
label_V_txt.x = config.center_x + 430;
label_V_txt.y = config.center_y - 55;

var label_I_txt = new createjs.Text();
label_I_txt.text = "Ένταση I";
label_I_txt.font = "14px Arial";
label_I_txt.color = "#006699";
label_I_txt.textAlign = "right";
label_I_txt.x = config.center_x + 430;
label_I_txt.y = config.center_y - 35;

var plot_labels = new createjs.Container();
plot_labels.addChild(label_VI_box);
plot_labels.addChild(label_V);
plot_labels.addChild(label_I);
plot_labels.addChild(label_V_txt);
plot_labels.addChild(label_I_txt);

stage.addChild(plot_labels);

stage.update();




// Create Clickable Areas

/*
// Theory button
var theory_btn_area = new createjs.Shape();
theory_btn_area.graphics.beginFill(config.click_area_color).drawCircle(0, 0, 25);
theory_btn_area.x = config.center_x - 505;
theory_btn_area.y = config.center_y - 285;
theory_btn_area.cursor = "pointer"; // show pointer on mouseover
stage.addChild(theory_btn_area);
stage.setChildIndex(theory_btn_area, 200);

// Application button
var application_btn = new createjs.Shape();
application_btn.graphics.beginFill(config.click_area_color).drawCircle(0, 0, 25);
application_btn.x = config.center_x - 505;
application_btn.y = config.center_y - 225;
application_btn.cursor = "pointer"; // show pointer on mouseover
stage.addChild(application_btn);
stage.setChildIndex(application_btn, 200);

// Investigation button
var invest_btn = new createjs.Shape();
invest_btn.graphics.beginFill(config.click_area_color).drawCircle(0, 0, 25);
invest_btn.x = config.center_x - 505;
invest_btn.y = config.center_y - 165;
invest_btn.cursor = "pointer"; // show pointer on mouseover
stage.addChild(invest_btn);
stage.setChildIndex(invest_btn, 200);
*/

// Pick Device Next
var device_arrow_next = new createjs.Shape();
device_arrow_next.graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 25, 25, 0);
device_arrow_next.x = config.center_x - 304;
device_arrow_next.y = config.center_y - 230;
device_arrow_next.cursor = "pointer"; // show pointer on mouseover
stage.addChild(device_arrow_next);
stage.setChildIndex(device_arrow_next, 200);

// Pick Device Previous
var device_arrow_prev = new createjs.Shape();
device_arrow_prev.graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 25, 25, 0);
device_arrow_prev.x = config.center_x - 458;
device_arrow_prev.y = config.center_y - 230;
device_arrow_prev.cursor = "pointer"; // show pointer on mouseover
stage.addChild(device_arrow_prev);
stage.setChildIndex(device_arrow_prev, 200);

// Pick Device Button
var device_add_img = new Image();
device_add_img.src = 'images/btn-add.png';

var device_add = new createjs.Bitmap(device_add_img);
device_add.scaleX = device_add.scaleY = 1;
device_add.x = config.center_x - 224;
device_add.y = config.center_y - 178;

device_add_img.onload = function () {
	stage.addChild(device_add);
	stage.setChildIndex(device_add, 200);
	stage.update();
}


// Add device button
var device_add_btn = new createjs.Shape();
device_add_btn.graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 110, 25, 0);
device_add_btn.x = config.center_x - 224;
device_add_btn.y = config.center_y - 178;
device_add_btn.cursor = "pointer"; // show pointer on mouseover
stage.addChild(device_add_btn);
stage.setChildIndex(device_add_btn, 200);



// Blackbox check answer button
var blackbox_check_btn = new createjs.Shape();
blackbox_check_btn.graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 106, 25, 0);
blackbox_check_btn.x = config.center_x + 345;
blackbox_check_btn.y = config.center_y - 188;
blackbox_check_btn.cursor = "pointer"; // show pointer on mouseover
stage.addChild(blackbox_check_btn);
stage.setChildIndex(blackbox_check_btn, 200);


// Remove 1st Device
var rm_device = new Array();
rm_device[0] = new createjs.Shape();
rm_device[0].graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 25, 25, 0);
rm_device[0].x = config.center_x - 310;
rm_device[0].y = config.center_y + 115;
rm_device[0].cursor = "pointer"; // show pointer on mouseover
stage.addChild(rm_device[0]);
stage.setChildIndex(rm_device[0], 200);

// Remove 2st Device
rm_device[1] = new createjs.Shape();
rm_device[1].graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 25, 25, 0);
rm_device[1].x = config.center_x - 115;
rm_device[1].y = config.center_y + 115;
rm_device[1].cursor = "pointer"; // show pointer on mouseover
stage.addChild(rm_device[1]);
stage.setChildIndex(rm_device[1], 200);

// Remove 3st Device
rm_device[2] = new createjs.Shape();
rm_device[2].graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 25, 25, 0);
rm_device[2].x = config.center_x + 80 ;
rm_device[2].y = config.center_y + 115;
rm_device[2].cursor = "pointer"; // show pointer on mouseover
stage.addChild(rm_device[2]);
stage.setChildIndex(rm_device[2], 200);

// Remove 4st Device
rm_device[3] = new createjs.Shape();
rm_device[3].graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 25, 25, 0);
rm_device[3].x = config.center_x + 275;
rm_device[3].y = config.center_y + 115;
rm_device[3].cursor = "pointer"; // show pointer on mouseover
stage.addChild(rm_device[3]);
stage.setChildIndex(rm_device[3], 200);

// Remove 5st Device
rm_device[4] = new createjs.Shape();
rm_device[4].graphics.beginFill(config.click_area_color).drawRoundRect(0, 0, 25, 25, 0);
rm_device[4].x = config.center_x + 470;
rm_device[4].y = config.center_y + 115;
rm_device[4].cursor = "pointer"; // show pointer on mouseover
stage.addChild(rm_device[4]);
stage.setChildIndex(rm_device[4], 200);





// Enable Mouseover on stage
stage.enableMouseOver();





// Stage update
stage.update();

